package cn.estsh.i3plus.ext.mes.pcn.apiservice.controller.busi.spot;


import cn.estsh.i3plus.ext.mes.pcn.api.busi.spot.IMesSpotCheckOrderService;
import cn.estsh.i3plus.ext.mes.pcn.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.mes.bean.MesSpotCheckOrder;
import cn.estsh.impp.framework.boot.auth.AuthUtil;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@Api(tags = "点检单页面")
@RequestMapping(MesCommonConstant.MES_YANFEN + "/spot-check-order")
@Slf4j
public class MesSpotCheckOrderController {

    @Autowired
    private IMesSpotCheckOrderService spotCheckOrderService;


    @GetMapping("/query-pager")
    @ApiOperation(value = "查询点检单")
    public ResultBean querySpotCheckOrderByPager(MesSpotCheckOrder spotCheckOrder, Pager pager) {

        try {

            spotCheckOrder.setOrganizeCode(AuthUtil.getOrganizeCode());
            return ResultBean.success("查询成功").setListPager(spotCheckOrderService.querySpotCheckOrder(spotCheckOrder, pager));
        } catch (ImppBusiException imppException) {
            return ResultBean.fail(imppException);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

    @GetMapping("/scan-produce")
    @ApiOperation(value = "扫描产品条码")
    public ResultBean querySpotCheckOrderByPager(MesSpotCheckOrder spotCheckOrder) {

        try {

            spotCheckOrder.setOrganizeCode(AuthUtil.getOrganizeCode());
            return ResultBean.success("查询成功").setResultObject(spotCheckOrderService.scanProduceSn(spotCheckOrder));
        } catch (ImppBusiException imppException) {
            return ResultBean.fail(imppException);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

    @GetMapping("/query-result")
    @ApiOperation(value = "查询点检单明细")
    public ResultBean queryWorkOrderByPager(MesSpotCheckOrder spotCheckOrder) {

        try {
            spotCheckOrder.setOrganizeCode(AuthUtil.getOrganizeCode());

            return ResultBean.success("查询成功").setResultObject(spotCheckOrderService.querySpotCheckOrderResult(spotCheckOrder));
        } catch (ImppBusiException imppException) {
            return ResultBean.fail(imppException);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }


}
