package cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.busi;

import cn.estsh.i3plus.ext.mes.pcn.api.busi.spot.IMesSpotCheckOrderService;
import cn.estsh.i3plus.ext.mes.pcn.pojo.model.MesSpotCheckOrderModel;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.base.common.PagerHelper;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesSpotCheckOrder;
import cn.estsh.i3plus.pojo.mes.bean.MesSpotCheckOrderPart;
import cn.estsh.i3plus.pojo.mes.bean.MesSpotCheckOrderResult;
import cn.estsh.i3plus.pojo.mes.repository.MesSpotCheckOrderPartRepository;
import cn.estsh.i3plus.pojo.mes.repository.MesSpotCheckOrderRepository;
import cn.estsh.i3plus.pojo.mes.repository.MesSpotCheckOrderResultRepository;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;

/**
 * @Description :
 * @Reference :
 * @Author :
 * @CreateDate : 2024-05-15 20:50
 * @Modify:
 **/
public class MesSpotCheckOrderService implements IMesSpotCheckOrderService {

    @Autowired
    private MesSpotCheckOrderRepository spotCheckOrderRepository;

    @Autowired
    private MesSpotCheckOrderResultRepository spotCheckOrderResultRepository;
    @Autowired
    private MesSpotCheckOrderPartRepository spotCheckOrderPartRepository;

    @Override
    public ListPager<MesSpotCheckOrder> querySpotCheckOrder(MesSpotCheckOrder spotCheckOrder, Pager pager) {

        DdlPackBean packBean = getDdlPackBean(spotCheckOrder);

        pager = PagerHelper.getPager(pager, spotCheckOrderRepository.findByHqlWhereCount(packBean));

        List<MesSpotCheckOrder> resultList = spotCheckOrderRepository.findByHqlWherePage(packBean, pager);

        return new ListPager<>(resultList, pager);

    }

    @Override
    public MesSpotCheckOrderModel scanProduceSn(MesSpotCheckOrder spotCheckOrder) {
        return null;
    }

    @Override
    public MesSpotCheckOrderModel querySpotCheckOrderResult(MesSpotCheckOrder spotCheckOrder) {
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(spotCheckOrder.getOrganizeCode());
        DdlPreparedPack.getNumEqualPack(spotCheckOrder.getId(), "pid", packBean);
        List<MesSpotCheckOrderResult> orderResultList = spotCheckOrderResultRepository.findByHqlWhere(packBean);
        List<MesSpotCheckOrderPart> orderPartList = spotCheckOrderPartRepository.findByHqlWhere(packBean);

        MesSpotCheckOrderModel model = new MesSpotCheckOrderModel();
        model.setOrderResultList(orderResultList);
        model.setOrderPartList(orderPartList);
        return model;
    }

    private DdlPackBean getDdlPackBean(MesSpotCheckOrder spotCheckOrder) {

        DdlPackBean packBean = DdlPackBean.getDdlPackBean(spotCheckOrder.getOrganizeCode());
        DdlPreparedPack.getStringLikerPack(spotCheckOrder.getWorkCenterCode(), "workCenterCode", packBean);
        DdlPreparedPack.getStringLikerPack(spotCheckOrder.getWorkCellCode(), "workCellCode", packBean);
        DdlPreparedPack.getStringLikerPack(spotCheckOrder.getSpotCheckOrderNo(), "spotCheckOrderNo", packBean);
        return packBean;
    }
}
